package require mqtt
package require rl_json

set SERVER "test.mosquitto.org" ;# сервер для тестов
set MSGS {}		;# сообщения для MQL
set MQTT {}		;# дескриптор mqtt
set root "atcl/8891/talk" ;# топик
set connected 0	;# соединён/нет

proc receive {} {
	set ret $::MSGS
	set ::MSGS {}
	set ret
}
proc start {} {
	set ::MQTT [ mqtt new ]
	$::MQTT connect "" $::SERVER
	$::MQTT subscribe "\$SYS/local/connection" [ list OnConnection ]
	$::MQTT subscribe "$::root/#" [ list OnMessage ]
}
proc stop {} {
	if { $::MQTT != {} } {
		catch { $::MQTT destroy }
		catch {rename $::MQTT {} }
		set ::MQTT {}
		set connected ""
	}
}
proc send { who args } {
	if { !$::connected } {
		return
	}
	# payloadformat указывает что передаём текст в utf-8
	$::MQTT publish -properties {PayloadFormatIndicator 1} $::root/$who [ join $args " " ] 0 1
}
proc OnConnection { topic message retain args } {
	set state [ dict get $message state ]
	if { $state == "connected" } {
		set ::connected 1
		ToMQL 1
	} elseif { $state == "disconnected" } {
		set ::connected 0
		ToMQL 0
	}
}
proc OnMessage { topic message retain args } {
	set path [ split $topic "/" ]
	set who [ lindex $path end ]
	if { $retain } {
		ToMQL 3 $who $message
	} else {
		ToMQL 2 $who $message
	}
}
proc ToMQL { code args } {
	lappend ::MSGS [ list $code {*}$args ]
}
